Index: /data/trunk/AUTHORS
===================================================================
--- /data/trunk/AUTHORS	(revision 6962)
+++ /data/trunk/AUTHORS	(revision 6963)
@@ -1,12 +1,56 @@
-Here we list the authors of all the media files in this repository. All files are released under the CC by-sa license which can be found in the LICENSE file in this directory, unless otherwise specified.
+﻿Here we list the authors of all the media files in this repository. All files are released under the CC by-sa license which can be found in the LICENSE file in this directory, unless otherwise specified.
 
 File                                                        Author
-audio/ambient/allgorythm-lift_up.ogg                        All-Go-Rhythm - Thierry Zaugg (www.bediff.com)
-audio/ambient/allgorythm-resonance_blaster.ogg              All-Go-Rhythm - Thierry Zaugg (www.bediff.com)
-audio/ambient/luke_grey_-_hypermode.ogg                     Lukas Grauer
-audio/ambient/mainmenu.wav                                  Raphaël Jecker
-audio/ambient/task_horizon_-_menu1.ogg                      unknown
-audio/ambient/tha_silent_partner_-_void.ogg                 unknown
+audio/ambient/default/allgorythm-lift_up.ogg                All-Go-Rhythm - Thierry Zaugg (www.bediff.com)
+audio/ambient/default/allgorythm-resonance_blaster.ogg      All-Go-Rhythm - Thierry Zaugg (www.bediff.com)
+audio/ambient/default/AlphaCentauri.ogg                     Kevin Young
+audio/ambient/default/Asteroid_rocks.ogg                    Kevin Young - Samples (License: CC Sampling+) from: ERH (Cinematic Deep Bass Rumble) and Jovica (ESERBEZE Granular Scape 22)
+audio/ambient/default/Earth.ogg                             Kevin Young
+audio/ambient/default/Fight1.ogg                            Kevin Young
+audio/ambient/default/Ganymede.ogg                          Kevin Young - Samples (License: CC Sampling+) from: yewbic (Ambience 3)
+audio/ambient/default/Jupiter.ogg                           Kevin Young - Samples (License: CC Sampling+) from: yewbic (Ambience 3)
+audio/ambient/default/luke_grey_-_hypermode.ogg             Lukas Grauer
+audio/ambient/default/mainmenu.ogg                          Raphaël Jecker
+audio/ambient/default/Mars.ogg                              Kevin Young
+audio/ambient/default/Nebula_metal.ogg                      Kevin Young - Samples (License: CC Sampling+) from: Sea Fury (Zap2) and Digifishmusic (Infinite Thunder)
+audio/ambient/dnb/AlphaCentauri.ogg                         Blal - Carnivore (Shadow Infestation EP), Licence: CC by-nc-nd 2.5
+audio/ambient/dnb/Asteroid_rocks.ogg                        Kevin Young - Samples (License: CC Sampling+) from: ERH (Cinematic Deep Bass Rumble) and Jovica (ESERBEZE Granular Scape 22)
+audio/ambient/dnb/Earth.ogg                                 403 - Unmute (Unmute EP), License: CC by-nc-sa 3.0
+audio/ambient/dnb/Fight1.ogg                                Throttler - Obey (Shadow Infestation EP), Licence: CC by-nc-nd 2.5 	
+audio/ambient/dnb/Ganymede.ogg                              Nekura - Not Now (Shadow Infestation EP), Licence: CC by-nc-nd 2.5
+audio/ambient/dnb/Jupiter.ogg                               ICR - Even When Your Shadow Leaves You (ICR), Licence: CC by-nc-nd 2.5, www.exegene.com
+audio/ambient/dnb/mainmenu.ogg                              ICR - Shinumade Tatakau (ICR), Licence: CC by-nc-nd 2.5, www.exegene.com
+audio/ambient/dnb/Mars.ogg                                  Medium - Dead Effect (Shadow Infestation EP), Licence: CC by-nc-nd 2.5
+audio/ambient/dnb/Nebula_metal.ogg                          Kevin Young - Samples (License: CC Sampling+) from: Sea Fury (Zap2) and Digifishmusic (Infinite Thunder)
+audio/ambient/eightbit/AlphaCentauri.ogg                    Dr. Zilog - Sanguinary Sect Of Worship (All Hallows Eve in 8bit Hell), License: CC by-nc-sa 3.0 US
+audio/ambient/eightbit/Asteroid_rocks.ogg                   Kevin Young - Samples (License: CC Sampling+) from: ERH (Cinematic Deep Bass Rumble) and Jovica (ESERBEZE Granular Scape 22)
+audio/ambient/eightbit/Earth.ogg                            Erik Skiff- We're The Resistors (Resistor Anthems), License: CC by 3.0 US
+audio/ambient/eightbit/Fight1.ogg                           Baphomania - Roaming Spectral Shores (All Hallows Eve in 8bit Hell), License: CC by-nc-sa 3.0 US	
+audio/ambient/eightbit/Ganymede.ogg                         Erik Skiff- All Of Us (Resistor Anthems), License: CC by 3.0 US
+audio/ambient/eightbit/Jupiter.ogg                          NESMETAL - The Throes Of Wickedness (All Hallows Eve in 8bit Hell), License: CC by-nc-sa 3.0 US
+audio/ambient/eightbit/mainmenu.ogg                         H-Pizzle - Ghosts Of A Fallen Empire (All Hallows Eve in 8bit Hell), License: CC by-nc-sa 3.0 US
+audio/ambient/eightbit/Mars.ogg                             Erik Skiff- Underclocked (Resistor Anthems), License: CC by 3.0 US
+audio/ambient/eightbit/Nebula_metal.ogg                     Kevin Young - Samples (License: CC Sampling+) from: Sea Fury (Zap2) and Digifishmusic (Infinite Thunder)
+audio/sounds/Button_press1.ogg                              Corsica S - blip10, License: CC Sampling+
+audio/sounds/Button_press2.ogg                              Corsica S - blip11, License: CC Sampling+
+audio/sounds/Button_press3.ogg                              Corsica S - blip12, License: CC Sampling+
+audio/sounds/Engine_charge.ogg                              Kevin Young - Samples (License: CC Sampling+) from: ReWire (SHMIR and Vents)
+audio/sounds/Engine_high.ogg                                Kevin Young - Samples (License: CC Sampling+) from: ReWire (SHMIR and Vents)
+audio/sounds/Engine_idle.ogg                                Kevin Young - Samples (License: CC Sampling+) from: ReWire (SHMIR and Vents)
+audio/sounds/Engine_low.ogg                                 Kevin Young - Samples (License: CC Sampling+) from: ReWire (SHMIR and Vents)
+audio/sounds/Engine_off.ogg                                 Kevin Young - Samples (License: CC Sampling+) from: ReWire (SHMIR and Vents)
 audio/sounds/laser1.wav                                     unknown
+audio/sounds/pong_bat.wav                                   unknown
+audio/sounds/pong_score.wav                                 unknown
+audio/sounds/pong_side.wav                                  unknown
+audio/sounds/Rocket_engine.ogg                              Kevin Young
+audio/sounds/Rocket_explosion.ogg                           Kevin Young - Samples (License: CC Sampling+) from: sleep (BOMB)
+audio/sounds/Rocket_launch.ogg                              Kevin Young
+audio/sounds/Ship_explosion.ogg                             Kevin Young - Samples (License: CC Sampling+) from: ERH (distant shot rumble 37 and distant shot 33)
+audio/sounds/Weapon_Chaingun.ogg                            Kevin Young - Samples (License: CC Sampling+) from: tcpp (Machinegun_ish) and joly1 (eurocopter_b2)
+audio/sounds/Weapon_HsW01.ogg                               Kevin Young - Samples (License: CC Sampling+) from: Infinity (smalllas)
+audio/sounds/Weapon_Laser.ogg                               Kevin Young - Samples (License: CC Sampling+) from: alienbomb (hit.2)
+audio/sounds/Weapon_LightningGun.ogg                        Kevin Young
+audio/sounds/Weapon_Plasma.ogg                              Kevin Young - Samples (License: CC Sampling+) from: DeadlyMustard (SP0000)
 fonts/bluebold.ttf                                          unknown
 fonts/bluecond.ttf                                          unknown