Index: trunk/src/lib/network/network_game_manager.cc
===================================================================
--- trunk/src/lib/network/network_game_manager.cc	(revision 6984)
+++ trunk/src/lib/network/network_game_manager.cc	(revision 6985)
@@ -701,5 +701,5 @@
   PRINTF(0)("uniqueID = %d\n", s->getUniqueID());
 
-  player->setControllable(p);
+  player->setPlayable(p);
 
 
Index: trunk/src/story_entities/game_world_data.cc
===================================================================
--- trunk/src/story_entities/game_world_data.cc	(revision 6984)
+++ trunk/src/story_entities/game_world_data.cc	(revision 6985)
@@ -230,5 +230,5 @@
   {
     playable = dynamic_cast<Playable*>(playableList->front());
-    this->localPlayer->setControllable(playable);
+    this->localPlayer->setPlayable(playable);
   }
 
Index: trunk/src/story_entities/multi_player_world_data.cc
===================================================================
--- trunk/src/story_entities/multi_player_world_data.cc	(revision 6984)
+++ trunk/src/story_entities/multi_player_world_data.cc	(revision 6985)
@@ -179,5 +179,5 @@
       {
         playable = dynamic_cast<Playable*>(playableList->front());
-        this->localPlayer->setControllable(playable);
+        this->localPlayer->setPlayable(playable);
       }
     }
@@ -250,6 +250,6 @@
   {
     playable = dynamic_cast<Playable*>(playableList->front());
-    this->localPlayer->disconnectControllable();
-    this->localPlayer->setControllable(playable);
+    this->localPlayer->disconnectPlayable();
+    this->localPlayer->setPlayable(playable);
     this->toggle = !this->toggle;
   }
@@ -257,11 +257,11 @@
   {
     playable = dynamic_cast<Playable*>(playableList->back());
-    this->localPlayer->disconnectControllable();
-    this->localPlayer->setControllable(playable);
+    this->localPlayer->disconnectPlayable();
+    this->localPlayer->setPlayable(playable);
     this->toggle = !this->toggle;
   }
 
 
-  Playable* pl = this->localPlayer->getControllable();
+  Playable* pl = this->localPlayer->getPlayable();
   PRINTF(0)("The current regisered playable is hid: %i\n", pl->getUniqueID());
 
Index: trunk/src/world_entities/player.cc
===================================================================
--- trunk/src/world_entities/player.cc	(revision 6984)
+++ trunk/src/world_entities/player.cc	(revision 6985)
@@ -37,5 +37,5 @@
   PRINTF(4)("PLAYER INIT\n");
 
-  this->controllable = NULL;
+  this->playable = NULL;
   this->hud.show();
 
@@ -53,11 +53,11 @@
 
 
-bool Player::setControllable(Playable* controllable)
+bool Player::setPlayable(Playable* playable)
 {
-  if(controllable != NULL && controllable->subscribePlayer(this))
+  if(playable != NULL && playable->subscribePlayer(this))
   {
-      this->controllable = controllable;
-      this->hud.setEnergyWidget(this->controllable->getHealthWidget());
-      this->hud.setWeaponManager(this->controllable->getWeaponManager());
+      this->playable = playable;
+      this->hud.setEnergyWidget(this->playable->getHealthWidget());
+      this->hud.setWeaponManager(this->playable->getWeaponManager());
       return true;
   }
@@ -66,11 +66,11 @@
 }
 
-bool Player::disconnectControllable()
+bool Player::disconnectPlayable()
  {
-   if(this->controllable == NULL) return true;
+   if(this->playable == NULL) return true;
 
-   if(this->controllable->unsubscribePlayer(this))
+   if(this->playable->unsubscribePlayer(this))
    {
-     this->controllable = NULL;
+     this->playable = NULL;
      this->hud.setEnergyWidget(NULL);
      this->hud.setWeaponManager(NULL);
@@ -96,9 +96,9 @@
        list<BaseObject*>::const_iterator node;
        for (node = objectList->begin(); node != objectList->end(); node++)
-         if (this->controllable != (*node) && (dynamic_cast<PNode*>(*node)->getAbsCoor() - this->controllable->getAbsCoor()).len() < 10.0)
+         if (this->playable != (*node) && (dynamic_cast<PNode*>(*node)->getAbsCoor() - this->playable->getAbsCoor()).len() < 10.0)
        {
 
-         this->disconnectControllable();
-         this->setControllable(dynamic_cast<Playable*>(*node));
+         this->disconnectPlayable();
+         this->setPlayable(dynamic_cast<Playable*>(*node));
 
          break;
@@ -107,6 +107,6 @@
    }
 
-   if (likely(this->controllable != NULL))
-     this->controllable->process(event);
+   if (likely(this->playable != NULL))
+     this->playable->process(event);
  }
 
Index: trunk/src/world_entities/player.h
===================================================================
--- trunk/src/world_entities/player.h	(revision 6984)
+++ trunk/src/world_entities/player.h	(revision 6985)
@@ -1,5 +1,5 @@
 /*!
  * @file player.h
- * Implements a basic controllable WorldEntity
+ * Implements a basic playable WorldEntity
  */
 
@@ -15,5 +15,5 @@
 
 
-//! Basic controllable WorldEntity
+//! Basic playable WorldEntity
 /**
   *  this is the debug player - actualy we would have to make a new
@@ -28,7 +28,7 @@
     virtual ~Player();
 
-    bool              setControllable(Playable* controllalble);
-    inline Playable*  getControllable() { return this->controllable; };
-    bool              disconnectControllable();
+    bool              setPlayable(Playable* controllalble);
+    inline Playable*  getPlayable() { return this->playable; };
+    bool              disconnectPlayable();
 
     void              weaponConfigChanged();
@@ -38,5 +38,5 @@
 
   private:
-    Playable*         controllable;                  //!< The one we controll or NULL if none
+    Playable*         playable;                  //!< The one we controll or NULL if none
     Hud               hud;                           //!< The HUD to be displayed for this Player.
 };